;;; RPL.LSP a program to reverse the direction of polylines
;;; Program by Tony Hotchkiss.  Enter RPL to start the program.

(defun c:rpl ()
  (setq again nil)
  (setq p-ent nil)
  (prompt "\nSelect a polyline: ")
  (while (not p-ent)
    (setq p-ent (car (entsel)))
    (if	(not p-ent)
      (prompt
	"\nNo object selected; select again: "
      ) ;_ end of prompt
      (progn
	(if (and (/= (dxf 0 p-ent) "POLYLINE")
		 (/= (dxf 0 p-ent) "LWPOLYLINE")
	    ) ;_ end of and
	  (progn
	    (prompt "\nNot a polyline, select again:"
	    ) ;_ end of prompt
	    (setq p-ent nil)
	  ) ; progn
	) ;_ end of if
      ) ;_ end of progn
    ) ;_ end of if
  ) ;_ end of while
  (setq	etype	  (dxf 0 p-ent)
	x-ent	  p-ent
	is-closed (dxf 70 p-ent)
  ) ; setq
  (if (= etype "LWPOLYLINE")
    (progn
      (setq num-vert (dxf 90 p-ent)
	    elist    (entget p-ent)
	    elist    (member (assoc 10 elist) elist)
	    vvlist   nil
      ) ; setq
      (repeat num-vert
	(setq vlist (list (cdr (assoc 10 elist))))
	(setq vlist
	       (append vlist
		       (list (cdr (assoc 42 elist)))
	       ) ;_ end of append
	) ;_ end of setq
	(setq vvlist (append vvlist
			     (list vlist)
		     ) ;_ end of append
	) ;_ end of setq
	(setq elist (cdr elist)
	      elist (member (assoc 10 elist) elist)
	) ; setq
      ) ; repeat
    ) ; progn lwpolyline
    (progn
      (setq vvlist nil
	    p-ent  (entnext p-ent)
      ) ; setq
      (while (/= "SEQEND"
		 (cdr
		   (assoc 0 (entget p-ent))
		 ) ;_ end of cdr
	     ) ;_ end of /=
	(setq vlist (list (dxf 10 p-ent)))
	(setq vlist (append vlist
			    (list (dxf 42 p-ent))
		    ) ;_ end of append
	) ;_ end of setq
	(setq vvlist (append vvlist
			     (list vlist)
		     ) ;_ end of append
	) ;_ end of setq
	(setq p-ent (entnext p-ent))
      ) ; while
    ) ; progn polyline
  ) ; if
  (setq	p-list	(mapcar 'car vvlist)
	p-list	(reverse p-list)
	b-list	(mapcar 'cadr vvlist)
	b-list	(reverse b-list)
	b-first	(car b-list)
	b-list	(cdr b-list)
	b-list	(append b-list (list b-first))
	b-list	(mapcar '- b-list)
  ) ; setq
  (setq	enlist (list '(0 . "LWPOLYLINE")
		     '(100 . "AcDbEntity")
		     '(100 . "AcDbPolyline")
		     (cons 90 (length p-list))
		     (cons 70 (dxf 70 x-ent))
		     (cons 8 (dxf 8 x-ent))
	       ) ; list
  ) ; setq
  (setq elst nil)
  (repeat (length p-list)
    (setq
      elst (append elst
		   (list (cons 10 (car p-list)))
	   ) ;_ end of append
    ) ; setq
    (setq
      elst (append elst
		   (list (cons 42 (car b-list)))
	   ) ;_ end of append
    ) ; setq
    (setq p-list (cdr p-list))
    (setq b-list (cdr b-list))
  ) ; repeat
  (setq enlist (append enlist elst))
  (entdel x-ent)
  (entmake enlist)
  (prompt "\nPolyline direction is reversed.\n ")
  (princ)
) ; rpl

(defun dxf (code ename)
  (cdr (assoc code (entget ename)))
) ;_ end of dxf
